>

> module Main where
> import Impl (allNames, strictPosition,
>               callGraph, callGraphSCCs,
>               CallGraphEdge(..), analyseFunctions,
>               analyserStartStates, CallGraph(..), SCC(..))
> import Compiler
> import Evaluator
> import Show
> import IO (progArgs)
> import StateType
> import AbsSyntax

\par

> main :: Dialogue
> main ~(r3 :_) =
>  [ReadFile (head progArgs),
>    AppendChan stdout 
>       (case r3 of
>           Str contents -> 
>               let initialState = compile (parse contents) 
>               in 
>                   [(last (showResults [initialState]))] ++ "\n"
>
>           Failure    _ -> "Can't open " ++ (head progArgs))]
>


% file ends here
