>

> module Main where
> main :: Dialogue
> main ~(StrList progArgs : ~(r3 :_)) =
>   [
>    GetArgs,
>    ReadFile name,
>    AppendChan stdout 
>       (case r3 of
>           Str contents -> 
>               unlines [show (convert 0.0 l) | l <- lines contents]
>           Failure _ -> "Can't open " ++ name)]
>   where 
>       (name :_) = progArgs
>
> convert :: Float -> String -> Float
> convert f (' ':xs) = convert f (dropWhile isSpace xs)
> convert f (':':xs) = f * 60.0 + convert 0.0 xs
> convert f ('.':xs) = f + (convert 0.0 xs)/(10.0^(length xs))
> convert f (x:xs) = convert (f*10.0+(fromInt ((ord x) - (ord '0')))) xs
> convert f [] = f

% file ends here







