-- nucleic2.core produced from
--
-- nucleic2.gsc				Mon Mar 13 11:41:09 1995
--
-- This program produced by gofc 1.02 (2.30) from:
--	/usr/lib/Gofer/standard.prelude
--	nucleic2.hs
--
-- all float constants approximated by Top
help = "press :? for a list of commands";

const k x       = k;
id    x         = x;
curry f a b     =  f (Cons{1,2} a b);
uncurry f c = case c of 
                <1> a b -> f a b;

fst y   = case y of 
                <1> x1 x2 -> x1;

snd y   = case y of 
                <1> x1 x2 -> x2;

fst3 y  = case y of 
                <1> x1 x2 x3 -> x1;

snd3 y  = case y of 
                <1> x1 x2 x3 -> x2;

thd3 y  = case y of 
                <1> x1 x2 x3 -> x3;

flip  f x y     = f y x;

-- Boolean functions: -------------------------------------------------------

binand x y = case x of 
                <1> -> Cons{2,0};
                <2> -> x;

binor x y = case x of
                <1> -> x;
                <2> -> Cons{2,0};

not x = case x of
        <2> -> Cons{1,0};
        <1> -> Cons{2,0};

and xs = foldr binand Cons{2,0} xs;
or xs = foldr binor Cons{1,0} xs;

any p xs = or ((map p) xs);
all p xs = and ((map p) xs);

otherwise       = Cons{2,0};

-- Character functions: -----------------------------------------------------

isAscii c     =  ord c < 128;

isControl c   =  binor (c < ' ') (c == '\DEL');

isPrint c     =  binand (c >= ' ') (c <= '~');

isSpace c     =  binor (c == ' ') (binor (c == '\t') (binor (c == '\n') 
                        (binor (c == '\r') (binor (c == '\f') (c == '\v')))));

isUpper c     =  binand (c >= 'A') (c <= 'Z');
isLower c     =  binand (c >= 'a') (c <= 'z');

isAlpha c     =  binor (isUpper c) (isLower c);
isDigit c     =  binand (c >= '0') (c <= '9');
isAlphanum c  =  binor (isAlpha c) (isDigit c);

toUpper c = if (isLower c) (chr ((ord c - (ord 'a')) + (ord 'A'))) c;
toLower c = if (isUpper c) (chr ((ord c - (ord 'A')) + (ord 'a'))) c;

minChar = chr 0;
maxChar = chr 255;

even x = ((x / 2) * 2) == x;
odd x  = not(even x);

rem x y  = x - (x / y) * y;
gcd' x y = if (y == 0) x (gcd' y (rem x y));
gcd x y  = gcd' (abs x) (abs y);

lcm x y  = if (y == 0) 0 (if (x == 0) 0 (abs ((x / (gcd x y)) * y)));

power x y     = if (y == 0) 1 (power' x (y - 1) x);
power' x n y  = if (n == 0) y (power'' x n y);
power'' x n y = if (even n) (power'' (x * x) (n / 2) y) 
				(power' x (n - 1) (x * y));

abs x = if (x >= 0) x (negate x);

signum x = if (x == 0) 0 (if (x > 0) 1 (negate 1));

plus x y  = x + y;
minus x y = x - y;
mul x y   = x * y;

sum xs     = foldl' plus 0 xs;
product xs = foldl' mul 1 xs;

sums xs     = scanl plus 0 xs;
products xs = scanl mul 1 xs;

-- Standard list processing functions: --------------------------------------

head x = case x of
             <2> y z -> y;

last x = case x of 
             <2> y z -> (case z of 
                             <1> -> y;
                             <2> a b -> last z);

tail x = case x of 
             <2> y z -> z;

init x = case x of
             <2> y z -> (case z of 
                             <1> -> Cons{1,0};
                             <2> a b -> Cons{2,2} y (init z));

append xs ys = case xs of 
                   <1> -> ys;
                   <2> z zs -> Cons{2,2} z (append zs ys);

length xs = foldl' lam_length 0 xs;
lam_length a b = a + 1;

at x y = case x of <2> a b -> if (y == 0) a (at b (y - 1)); 

iterate f x = Cons{2,2} x (iterate f (f x));
repeat x    = Cons{2,2} x (repeat x);
cycle xs    = letrec xs' = append xs xs' in xs';
copy n x    = take n (repeat x);
nub x = case x of
                <1> -> Cons{1,0};
                <2> y z -> Cons{2,2} y (nub (filter ((compose not eq) y) z));

reverse xs = foldl (flip cons22) Cons{1,0} xs;

eq x y = x == y;

elem x xs = any (eq x) xs;
notElem x xs = not (elem x xs);

max x y = if (x < y) y x;
min x y = if (x < y) x y;

maximum xs = foldl1 max xs;
minimum xs = foldl1 min xs;

concat xs = foldr append Cons{1,0} xs;

cons22 x xs = Cons{2,2} x xs;

transpose xs         = foldr lam_transpose Cons{1,0} xs;
lam_transpose xs xss = zipWith cons22 xs (append xss (repeat Cons{1,0}));

null x = case x of 
             <1> -> Cons{2,0};
             <2> a b -> Cons{1,0};

delone xs ys = foldl del' xs ys ;
del' x y = case x of 
               <1> -> Cons{1,0};
               <2> a b -> if (a == y) b (Cons{2,2} x (del' b y));

map f xs = case xs of
               <1> -> Cons{1,0};
               <2> a b -> Cons{2,2} (f a) (map f b);

filter p xs = case xs of
                  <1> -> Cons{1,0};
                  <2> a b -> let xs' = filter p b in 
                         if (p a) (Cons{2,2} a xs') xs';

foldl f z xs = case xs of
                   <1> -> z;
                   <2> a b -> foldl f (f z a) b;

foldl1 f ys = case ys of
                  <2> x xs -> foldl f x xs;

foldl' f a ys = case ys of 
                    <1> -> a;
                    <2> x xs -> strict (foldl' f) (f a x) xs;

scanl f q xs  = case xs of
                    <1> -> Cons{2,2} q Cons{1,0};
                    <2> x xs1 ->  Cons{2,2} q (scanl f (f q x) xs1);

scanl1 f ys   = case ys of
                    <2> x xs -> scanl f x xs;

scanl' f q xs = case xs of
                    <1> -> Cons{2,2} q Cons{1,0};
                    <2> x xs1 -> 
                       Cons{2,2} q (strict (scanl' f) (f q x) xs1);

foldr f z ys = case ys of
                   <1> -> z;
                   <2> x xs -> f x (foldr f z xs);

foldr1 f ys  = case ys of 
                   <2> x xs -> (case xs of
                                    <1> -> x;
                                    <2> a b -> f x (foldr1 f xs));

scanr f q0 ys = case ys of 
                    <1> -> Cons{2,2} q0 Cons{1,0};
                    <2> x xs -> 
                       (case (scanr f q0 xs) of
                            <2> q qs -> 
                               Cons{2,2} (f x q) (Cons{2,2} q qs));

scanr1 f ys = case ys of 
                <2> x xs -> 
                   (case xs of 
                        <1> -> x;
                        <2> a b -> 
                           (case (scanr1 f xs) of
                                <2> q qs -> 
                                   Cons{2,2} (f x q) (Cons{2,2} q qs)));

take n ys = case (n == 0) of
                <2> -> Cons{1,0};
                <1> -> (case ys of
                            <1> -> Cons{1,0};
                            <2> x xs -> Cons{2,2} x (take (n - 1) xs));

drop n ys = case (n == 0) of 
                <2> -> ys;
                <1> -> (case ys of
                            <1> -> Cons{1,0};
                            <2> x xs -> drop (n - 1) xs);

lam_splitAt n ys = 
 case ys of
     <1> -> Cons{1,2} Cons{1,0} Cons{1,0};
     <2> x xs -> (case splitAt (n - 1) xs of
                      <1> xs' xs'' -> Cons{1,2} (Cons{2,2} x xs') xs'');

splitAt n ys = if (n == 0) (Cons{1,2} Cons{1,0} ys)
                         (lam_splitAt n ys);

takeWhile p ys = 
 case ys of
     <1> -> Cons{1,0};
     <2> x xs -> if (p x) (Cons{2,2} x (takeWhile p xs)) Cons{1,0};

takeUntil p ys = case ys of 
                     <1> -> Cons{1,0};
                     <2> x xs -> if (p x) (Cons{2,2} x Cons{1,0}) 
                                          (Cons{2,2} x (takeUntil p xs));

dropWhile p ys = case ys of
                     <1> -> Cons{1,0};
                     <2> x xs -> if (p x) (dropWhile p xs) ys;

span p ys = 
 case ys of 
     <1> -> Cons{1,2} Cons{1,0} Cons{1,0};
     <2> x xs -> 
        if (p x) (case span p xs of 
                      <1> as bs -> Cons{1,2} (Cons{2,2} x as) bs)
                 (Cons{1,2} Cons{1,0} ys);

break p xs = span (compose not p) xs;

lines s =
 case s of 
     <1> -> Cons{1,0};
     <2> a b -> 
        case break (eq n) s of 
          <1> l s' -> 
             Cons{2,2} l 
               (if (null s') Cons{1,0} (lines (tail s')));

words s = case dropWhile isSpace s of
              <1> -> Cons{1,0};
              <2> t' t'' -> (case break isSpace t' of 
                                 <1> w s'' -> Cons{2,2} w (words s''));

unlines xs    = concat (map lam_unlines xs);
lam_unlines l = append l "\n";

unwords ws = case ws of 
                 <1> -> Cons{1,0};
                 <2> a b -> foldr1 lam_unwords ws;

lam_unwords w s = append w (Cons{2,2} ' ' s);

merge xs1 ys1 = 
 case xs1 of
     <1> -> ys1;
     <2> x xs -> (case ys1 of 
                      <1> -> xs1;
                      <2> y ys -> if (x <= y) 
                                     (Cons{2,2} x (merge xs ys1))
                                     (Cons{2,2} y (merge xs1 ys)));

sort xs = foldr insert Cons{1,0} xs;

insert x zs = case zs of
                  <1> -> Cons{2,2} x Cons{1,0};
                  <2> y ys -> if (x <= y) 
                                 (Cons{2,2} x zs) 
                                 (Cons{2,2} y (insert x ys));

gt x y = x > y;
le x y = x <= y;

qsort ys = case ys of
               <1> -> Cons{1,0};
               <2> x xs -> append (qsort (filter (gt x) xs)) 
                                  (append (Cons{2,2} x Cons{1,0})
                                        (qsort (filter (le x) xs)));

zip as bs = zipWith lam_zip as bs;
lam_zip a b = Cons{1,2} a b;

zip3 as bs cs = zipWith3 lam_zip3 as bs cs;
lam_zip3 a b c = Cons{1,3} a b c;

zip4 as bs cs ds = zipWith4 lam_zip4 as bs cs ds;
lam_zip4 a b c d = Cons{1,4}  a b c d;

zip5 as bs cs ds es = zipWith5 lam_zip5 as bs cs ds es;
lam_zip5 a b c d e = Cons{1,5} a b c d e;

zip6 as bs cs ds es fs = zipWith6 lam_zip6 as bs cs ds es fs;
lam_zip6 a b c d e f = Cons{1,6} a b c d e f;

zip7 as bs cs ds es fs gs = zipWith7 lam_zip7 as bs cs ds es fs gs;
lam_zip7 a b c d e f g = Cons{1,7} a b c d e f g;

zipWith z xs ys =
 case xs of
   <1> -> Cons{1,0};
   <2> a as -> case ys of
                 <1> -> Cons{1,0};
                 <2> b bs -> Cons{2,2} 
                               (z a b) 
                               (zipWith z as bs);

zipWith3 z xs1 xs2 xs3 =
 case xs1 of
   <1> -> Cons{1,0};
   <2> a as -> 
      case xs2 of
        <1> -> Cons{1,0};
        <2> b bs -> case xs3 of
                      <1> -> Cons{1,0};
                      <2> c cs -> Cons{2,2} 
                                    (z a b c) 
                                    (zipWith3 z as bs cs);

zipWith4 z xs1 xs2 xs3 xs4 =
 case xs1 of
   <1> -> Cons{1,0};
   <2> a as -> 
      case xs2 of
        <1> -> Cons{1,0};
        <2> b bs -> 
           case xs3 of
             <1> -> Cons{1,0};
             <2> c cs -> 
                case xs4 of 
                  <1> -> Cons{1,0};
                  <2> d ds -> Cons{2,2} 
                                (z a b c d) 
                                (zipWith4 z as bs cs ds);

zipWith5 z xs1 xs2 xs3 xs4 xs5 =
 case xs1 of
   <1> -> Cons{1,0};
   <2> a as ->
      case xs2 of
        <1> -> Cons{1,0};
        <2> b bs -> 
           case xs3 of
             <1> -> Cons{1,0};
             <2> c cs -> 
                case xs4 of 
                  <1> -> Cons{1,0};
                  <2> d ds -> 
                     case xs5 of
                       <1> -> Cons{1,0};
                       <2> e es -> Cons{2,2} 
                                     (z a b c d e) 
                                     (zipWith5 z as bs cs ds es);

zipWith6 z xs1 xs2 xs3 xs4 xs5 xs6 =
 case xs1 of
   <1> -> Cons{1,0};
   <2> a as ->
      case xs2 of
        <1> -> Cons{1,0};
        <2> b bs -> 
           case xs3 of
             <1> -> Cons{1,0};
             <2> c cs -> 
                case xs4 of 
                  <1> -> Cons{1,0};
                  <2> d ds -> 
                     case xs5 of
                       <1> -> Cons{1,0};
                       <2> e es -> 
                          case xs6 of
                            <1> -> Cons{1,0};
                            <2> f fs -> Cons{2,2} 
                                          (z a b c d e f ) 
                                          (zipWith6 z as bs cs ds es fs);

zipWith7 z xs1 xs2 xs3 xs4 xs5 xs6 xs7 = 
 case xs1 of
   <1> -> Cons{1,0};
   <2> a as -> 
      case xs2 of
        <1> -> Cons{1,0};
        <2> b bs -> 
           case xs3 of
             <1> -> Cons{1,0};
             <2> c cs -> 
                case xs4 of
                  <1> -> Cons{1,0};
                  <2> d ds -> 
                     case xs5 of
                       <1> -> Cons{1,0};
                       <2> e es -> 
                          case xs6 of
                            <1> -> Cons{1,0};
                            <2> f fs -> 
                               case xs7 of 
                                 <1> -> Cons{1,0};
                                 <2> g gs -> 
                                    Cons{2,2} 
                                      (z a b c d e f g) 
                                      (zipWith7 z as bs cs ds es fs gs);

unzip ys =
 case ys of 
   <1> -> Cons{1,2} Cons{1,0} Cons{1,0};
   <2> x xs -> 
      case x of
        <1> x' x'' -> 
           case unzip xs of
             <1> y' y'' -> Cons{1,2} (Cons{2,2} x' y') 
                                     (Cons{2,2} x'' y'');

-- simulate shows strict behaviour
show x      = case x of 
                <1> -> 1;

cjustify n s = letrec m = n - (length s); halfm = m / 2 in 
        append (space halfm) (append s (space (m - halfm)));
ljustify n s = append s (space (n - (length s)));
rjustify n s = append (space (n - (length s))) s;

space n      = copy n ' ';

layn xs = lay 1 xs;
lay n ys = 
 case ys of
   <1> -> Cons{1,0};
   <2> x xs -> append (rjustify 4 (show n)) 
                      (append ") " 
                         (append x (append "\n" (lay (n + 1) xs))));

main = main;

enumFrom x = Cons{2,2} x (enumFrom (x + 1));

until p f x = if (p x) x (until p f (f x));

until' p f x = takeUntil p (iterate f x);

-- simulate error
error xs = show xs;

-- end of standard.prelude.core

-- nucleic2.core

fadd a b = a + b;

fsub a b = a - b;

fmul a b = a * b;

fdiv a b = a / b;

feq a b = a == b;

flt a b = a < b;

fle a b = a <= b;

fgt a b = a > b;

fge a b = a >= b;

fneg a = negate a;

-- We model the trig functions strictness behaviour only

fsin a = strict id a;

fcos a = strict id a;

fatan a = strict id a;

fsqrt a = strict id a;

constant_pi = Top;

constant_minus_pi = negate Top;

constant_pi2 = Top;

constant_minus_pi2 = negate Top;

math_atan2 a b = strict (strict k a) b;

pt_sub o2 o1 = 
 case o2 of 
 	<1> o5 o4 o3 -> case o1 of 
		<1> o8 o7 o6 -> Cons{1,3} (o5 - o8) (o4 - o7) (o3 - o6);

pt_dist o2 o1 = 
 case o2 of
	<1> o5 o4 o3 -> case o1 of
        	<1> o8 o7 o6 -> let o9 = o5 - o8;
			o10 = o4 - o7;
			o11 = o3 - o6;
			in fsqrt ((o9 * o9) + (o10 * o10) + (o11 * o11));

pt_phi o1 = 
 case o1 of
	<1> o4 o3 o2 -> let o5 = math_atan2 o4 o2;
		in  math_atan2 (((fcos o5) * o2) + ((fsin o5) * o4)) o3;

pt_theta o1 = case o1 of
	<1> o4 o3 o2 -> math_atan2 o4 o2;

tfo_id = Cons{1,12} 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0;

tfo_apply o2 o1 = 
 case o2 of
	<1> o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 -> case o1 of
		<1> o17 o16 o15 -> Cons{1,3} ((o17 * o14) + (o16 * o11) + (o15 * o8) + o5)
			((o17 * o13) + (o16 * o10) + (o15 * o7) + o4) 
			((o17 * o12) + (o16 * o9) + (o15 * o6) + o3);

tfo_combine o2 o1 = case o2 of
	<1> o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 -> case o1 of
		<1> o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 -> 
			Cons{1,12} ((o14 * o26) + (o13 * o23) + (o12 * o20)) ((o14 * o25) + (o13 * o22) + (o12 * o19)) ((o14 * o24) + (o13 * o21) + (o12 * o18)) ((o11 * o26) + (o10 * o23) + (o9 * o20)) ((o11 * o25) + (o10 * o22) + (o9 * o19)) ((o11 * o24) + (o10 * o21) + (o9 * o18)) ((o8 * o26) + (o7 * o23) + (o6 * o20)) ((o8 o25) + (o7 * o22) + (o6 * o19)) ((o8 * o24) + (o7 * o21) + (o6 * o18)) ((o5 * o26) + (o4 * o23) + (o3 * o20) + o17) ((o5 * o25) + (o4 * o22) + (o3 * o19) + o16) ((o5 * o24) + (o4 * o21) + (o3 * o18) + o15);

tfo_inv_ortho o1 = case o1 of
	<1> o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> 
		Cons{1,12} o13 o10 o7 o12 o9 o6 o11 o8 o5 (fneg ((o13 * o4) + (o12 * o3) + (o11 * o2))) (fneg ((o10 * o4) + (o9 * o3) + (o8 * o2))) (fneg ((o7 * o4) + (o6 * o3) + (o5 * o2)));

tfo_align o3 o2 o1 = case o3 of
	<1> o6 o5 o4 -> case o2 of
		<1> o9 o8 o7 -> case o1 of
			<1> o12 o11 o10 -> letrec o13 = o12 - o6;
				o14 = o11 - o5;
				o15 = o10 - o4;
				o16 = pt_sub (Cons{1,3} o9 o8 o7) (Cons{1,3} o6 o5 o4);
				o17 = pt_phi o16;
				o18 = pt_theta o16;
				o19 = fsin o17;
				o20 = fsin o18;
				o21 = fcos o17;
				o22 = fcos o18;
				o23 = o19 * o20;
				o24 = o19 * o22;
				o25 = o21 * o20;
				o26 = o21 * o22;
				o27 = Cons{1,3} (o22 * o13 - o20 * o15) (o23 * o13 + o21 * o14 + o24 * o15) (o25 * o13 + (fneg (o19 * o14)) + o26 * o15);
				o28 = pt_theta o27;
				o29 = fcos o28;
				o30 = fsin o28;
				o31 = (fneg (o6 * o22)) + o4 * o20;
				o32 = ((fneg (o6 * o23)) - (o5 * o21)) - (o4 * o24);
				o33 = ((fneg (o6 * o25)) + o5 * o19) - (o4 * o26);
				in  Cons{1,12} (o22 * o29 - o25 * o30) o23 (o22 * o30 + o25 * o29) (o19 * o30) o21 (fneg (o19 * o29)) ((fneg (o20 * o29)) - o26 * o30) o24 (fneg (o20 * o30) + o26 * o29) (o31 * o29 - o33 * o30) o32 (o31 * o30 + o33 * o29);

is_A o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> (case o2 of
		<1> o39 o38 o37 o36 o35 o34 o33 o32 -> Cons{2,0};
		<2> o39 o38 o37 o36 o35 o34 -> Cons{1,0};
		<3> o39 o38 o37 o36 o35 o34 o33 o32 o40 -> Cons{1,0};
		<4> o39 o38 o37 o36 o35 -> Cons{1,0};);

is_C o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> (case o2 of
		<2> o37 o36 o35 o34 o33 o32 -> Cons{2,0};
       		<1> o39 o38 o37 o36 o35 o34 o33 o32 -> Cons{1,0};
		<3> o39 o38 o37 o36 o35 o34 o33 o32 o40 -> Cons{1,0};
		<4> o39 o38 o37 o36 o35 -> Cons{1,0};);

is_G o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> (case o2 of
		<3> o40 o39 o38 o37 o36 o35 o34 o33 o32 -> Cons{2,0};
		<2> o37 o36 o35 o34 o33 o32 -> Cons{1,0};
       		<1> o39 o38 o37 o36 o35 o34 o33 o32 -> Cons{1,0};
		<4> o39 o38 o37 o36 o35 -> Cons{1,0};);


nuc_C1' o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o17;

nuc_C2 o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o6;

nuc_C3' o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o11;

nuc_C4 o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o5;

nuc_C4' o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o20;

nuc_N1 o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o8;

nuc_O3' o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o9;

nuc_P o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o27;

nuc_dgf_base_tfo o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o31;

nuc_p_o3'_180_tfo o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o29;

nuc_p_o3'_275_tfo o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o30;

nuc_p_o3'_60_tfo o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> o28;

rA_N9 o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> case o2 of
		<1> o39 o38 o37 o36 o35 o34 o33 o32 -> o37;

rG_N9 o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> case o2 of
 		<3> o40 o39 o38 o37 o36 o35 o34 o33 o32 -> o38;

rA = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top Top Top Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,8} (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top Top (negate Top)));

rA01 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top Top Top Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate  Top) (negate  Top) Top (negate  Top) Top Top Top Top (negate {dict45} Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,8} (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top Top (negate Top)));

rA02 = Cons{1,30} (Cons{1,12} Top Top Top Top Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,8} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)));

rA03 = Cons{1,30} (Cons{1,12} (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,8} (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)));

rA04 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top Top Top (negate Top) Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,8} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)));

rA05 = Cons{1,30} (Cons{1,12} (negate Top) Top Top Top Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,8} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rA06 = Cons{1,30} (Cons{1,12} (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,8} (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)));

rA07 = Cons{1,30} (Cons{1,12} Top Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top) (Cons{1,12} Top Top Top Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top) (Cons{1,12} (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,8} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rA08 = Cons{1,30} (Cons{1,12} Top (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top (negate Top) Top Top) (Cons{1,12} Top Top Top Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top) (Cons{1,12} (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,8} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rA09 = Cons{1,30} (Cons{1,12} Top Top (negate Top) (negate Top) Top Top Top Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top Top Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top) (Cons{1,12} (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,8} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rA10 = Cons{1,30} (Cons{1,12} Top Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top) (Cons{1,12} Top Top Top Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top) (Cons{1,12} (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,8} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rAs = Cons{2,2} rA01 (Cons{2,2} rA02 (Cons{2,2} rA03 (Cons{2,2} rA04 (Cons{2,2} rA05 (Cons{2,2} rA06 (Cons{2,2} rA07 (Cons{2,2} rA08 (Cons{2,2} rA09 (Cons{2,2} rA10 Cons{1,0})))))))));

rC = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{2,6} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rC01 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{2,6} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rC02 = Cons{1,30} (Cons{1,12} Top Top Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{2,6} (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rC03 = Cons{1,30} (Cons{1,12} (negate Top) Top Top Top (negate Top) Top Top Top Top Top (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{2,6} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rC04 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) (negate Top) Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{2,6} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rC05 = Cons{1,30} (Cons{1,12} (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{2,6} (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top));

rC06 = Cons{1,30} (Cons{1,12} (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{2,6} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rC07 = Cons{1,30} (Cons{1,12} Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top Top Top) (Cons{1,12} Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top) (Cons{1,12} (negate Top) Top (negate Top) Top Top Top Top (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{2,6} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rC08 = Cons{1,30} (Cons{1,12} Top (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) Top (negate Top) Top Top) (Cons{1,12} Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top) (Cons{1,12} (negate Top) Top (negate Top) Top Top Top Top (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{2,6} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rC09 = Cons{1,30} (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top) (Cons{1,12} (negate Top) Top (negate Top) Top Top Top Top (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{2,6} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rC10 = Cons{1,30} (Cons{1,12} Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,12} Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top) (Cons{1,12} (negate Top) Top (negate Top) Top Top Top Top (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{2,6} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rCs = Cons{2,2} rC01 (Cons{2,2} rC02 (Cons{2,2} rC03 (Cons{2,2} rC04 (Cons{2,2} rC05 (Cons{2,2} rC06 (Cons{2,2} rC07 (Cons{2,2} rC08 (Cons{2,2} rC09 (Cons{2,2} rC10 Cons{1,0})))))))));

rG = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top Top Top Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{3,9} (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)));

rG01 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top Top Top Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{3,9} (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)));

rG02 = Cons{1,30} (Cons{1,12} Top Top Top Top Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{3,9} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)));

rG03 = Cons{1,30} (Cons{1,12} (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (G (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)));

rG04 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top Top Top (negate Top) Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{3,9} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)));

rG05 = Cons{1,30} (Cons{1,12} (negate Top) Top Top Top Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{3,9} (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top Top));

rG06 = Cons{1,30} (Cons{1,12} (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) Top Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top Top (negate Top) Top) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{3,9} (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)) (Cons{1,3} Top Top (negate Top)));

rG07 = Cons{1,30} (Cons{1,12} Top (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{3,9} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rG08 = Cons{1,30} (Cons{1,12} Top Top Top (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{3,9} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rG09 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{3,9} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top (negate Top) Top));

rG10 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{3,9} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rGs = Cons{2,2} rG01 (Cons{2,2} rG02 (Cons{2,2} rG03 (Cons{2,2} rG04 (Cons{2,2} rG05 (Cons{2,2} rG06 (Cons{2,2} rG07 (Cons{2,2} rG08 (Cons{2,2} rG09 (Cons{2,2} rG10 Cons{1,0})))))))));

rU = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{4,5} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rU01 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{4,5} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rU02 = Cons{1,30} (Cons{1,12} Top Top Top (negate Top) (negate Top) Top Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{4,5} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rU03 = Cons{1,30} (Cons{1,12} (negate Top) Top Top Top (negate Top) Top Top Top Top Top (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{4,5} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rU04 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) (negate Top) Top Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{4,5} (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rU05 = Cons{1,30} (Cons{1,12} (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{4,5} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) (negate Top)) (Cons{1,3} Top (negate Top) Top));

rU06 = Cons{1,30} (Cons{1,12} (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top (negate Top) Top) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (U (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

rU07 = Cons{1,30} (Cons{1,12} (negate Top) Top Top Top Top Top Top Top (negate Top) Top (negate Top) Top) (Cons{1,12} Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top (negate Top) (negate Top) Top) (Cons{1,12} Top (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) (negate Top) Top Top Top (negate Top) (negate Top) Top (negate Top) Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{4,5} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rU08 = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top (negate Top) (negate Top) Top) (Cons{1,12} Top (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) (negate Top) Top Top Top (negate Top) (negate Top) Top (negate Top) Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{4,5} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rU09 = Cons{1,30} (Cons{1,12} (negate Top) Top Top (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) Top (negate Top)) (Cons{1,12} Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top (negate Top) (negate Top) Top) (Cons{1,12} Top (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) (negate Top) Top Top Top (negate Top) (negate Top) Top (negate Top) Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{4,5} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rU10 = Cons{1,30} (Cons{1,12} (negate Top) Top (negate Top) (negate Top) (negate Top) Top Top Top Top Top (negate Top) (negate Top)) (Cons{1,12} Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top Top Top (negate Top) (negate Top) Top) (Cons{1,12} Top (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) (negate Top) Top Top Top (negate Top) (negate Top) Top (negate Top) Top (negate Top)) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{4,5} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rUs = Cons{2,2) rU01 (Cons{2,2) rU02 (Cons{2,2) rU03 (Cons{2,2) rU04 (Cons{2,2) rU05 (Cons{2,2) rU06 (Cons{2,2) rU07 (Cons{2,2) rU08 (Cons{2,2) rU09 (Cons{2,2) rU10 Cons{1,0})))))))));

rG' = Cons{1,30} (Cons{1,12} (negate Top) (negate Top) Top Top (negate Top) Top Top Top Top Top (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top Top (negate Top) (negate Top) Top (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{3,9} (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top) (Cons{1,3} Top Top Top));

rU' = Cons{1,30} (Cons{1,12} (negate Top) Top Top Top (negate Top) Top Top Top (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} (negate Top) (negate Top) (negate Top) Top Top (negate Top) Top (negate Top) (negate Top) Top Top (negate Top)) (Cons{1,12} Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top)) (Cons{1,12} Top Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) (negate Top) Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{4,5} (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top) (Cons{1,3} Top (negate Top) Top));

mk_var o3 o2 o1 = Cons{1,3} o3 o2 o1;

absolute_pos o2 o1 = case o2 of
	<1> o5 o4 o3 -> tfo_apply o4 o1;

atom_pos o2 o1 = case o1 of
	<1> o5 o4 o3 -> absolute_pos (Cons{1,3} o5 o4 o3) (o2 o3);

get_var o2 o1 = case o1 of
	<2> o4 o3 -> case o4 of
		<1> o7 o6 o5 -> if (o7 == o2) (Cons{1,3} o7 o6 o5)
						(get_var o2 o3);

make_relative_nuc o2 o1 = case o1 of
	<1> o32 o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 -> (case o3 of
 		<1> o40 o39 o38 o37 o36 o35 o34 o33 -> Cons{1,30} o32 o31 o30 o29 (tfo_apply o2 o28) (tfo_apply o2 o27) (tfo_apply o2 o26) (tfo_apply o2 o25) (tfo_apply o2 o24) (tfo_apply o2 o23) (tfo_apply o2 o22) (tfo_apply o2 o21) (tfo_apply o2 o20) (tfo_apply o2 o19) (tfo_apply o2 o18) (tfo_apply o2 o17) (tfo_apply o2 o16) (tfo_apply o2 o15) (tfo_apply o2 o14) (tfo_apply o2 o13) (tfo_apply o2 o12) (tfo_apply o2 o11) (tfo_apply o2 o10) (tfo_apply o2 o9) (tfo_apply o2 o8) (tfo_apply o2 o7) (tfo_apply o2 o6) (tfo_apply o2 o5) (tfo_apply o2 o4) (A (tfo_apply o2 o40) (tfo_apply o2 o39) (tfo_apply o2 o38) (tfo_apply o2 o37) (tfo_apply o2 o36) (tfo_apply o2 o35) (tfo_apply o2 o34) (tfo_apply o2 o33));
 		<2> o38 o37 o36 o35 o34 o33 -> Cons{1,30} o32 o31 o30 o29 (tfo_apply o2 o28) (tfo_apply o2 o27) (tfo_apply o2 o26) (tfo_apply o2 o25) (tfo_apply o2 o24) (tfo_apply o2 o23) (tfo_apply o2 o22) (tfo_apply o2 o21) (tfo_apply o2 o20) (tfo_apply o2 o19) (tfo_apply o2 o18) (tfo_apply o2 o17) (tfo_apply o2 o16) (tfo_apply o2 o15) (tfo_apply o2 o14) (tfo_apply o2 o13) (tfo_apply o2 o12) (tfo_apply o2 o11) (tfo_apply o2 o10) (tfo_apply o2 o9) (tfo_apply o2 o8) (tfo_apply o2 o7) (tfo_apply o2 o6) (tfo_apply o2 o5) (tfo_apply o2 o4) (C (tfo_apply o2 o38) (tfo_apply o2 o37) (tfo_apply o2 o36) (tfo_apply o2 o35) (tfo_apply o2 o34) (tfo_apply o2 o33));
		<3> o41 o40 o39 o38 o37 o36 o35 o34 o33 -> Cons{1,30} o32 o31 o30 o29 (tfo_apply o2 o28) (tfo_apply o2 o27) (tfo_apply o2 o26) (tfo_apply o2 o25) (tfo_apply o2 o24) (tfo_apply o2 o23) (tfo_apply o2 o22) (tfo_apply o2 o21) (tfo_apply o2 o20) (tfo_apply o2 o19) (tfo_apply o2 o18) (tfo_apply o2 o17) (tfo_apply o2 o16) (tfo_apply o2 o15) (tfo_apply o2 o14) (tfo_apply o2 o13) (tfo_apply o2 o12) (tfo_apply o2 o11) (tfo_apply o2 o10) (tfo_apply o2 o9) (tfo_apply o2 o8) (tfo_apply o2 o7) (tfo_apply o2 o6) (tfo_apply o2 o5) (tfo_apply o2 o4) (G (tfo_apply o2 o41) (tfo_apply o2 o40) (tfo_apply o2 o39) (tfo_apply o2 o38) (tfo_apply o2 o37) (tfo_apply o2 o36) (tfo_apply o2 o35) (tfo_apply o2 o34) (tfo_apply o2 o33));
		<4> o37 o36 o35 o34 o33 -> Cons{1,30} o32 o31 o30 o29 (tfo_apply o2 o28) (tfo_apply o2 o27) (tfo_apply o2 o26) (tfo_apply o2 o25) (tfo_apply o2 o24) (tfo_apply o2 o23) (tfo_apply o2 o22) (tfo_apply o2 o21) (tfo_apply o2 o20) (tfo_apply o2 o19) (tfo_apply o2 o18) (tfo_apply o2 o17) (tfo_apply o2 o16) (tfo_apply o2 o15) (tfo_apply o2 o14) (tfo_apply o2 o13) (tfo_apply o2 o12) (tfo_apply o2 o11) (tfo_apply o2 o10) (tfo_apply o2 o9) (tfo_apply o2 o8) (tfo_apply o2 o7) (tfo_apply o2 o6) (tfo_apply o2 o5) (tfo_apply o2 o4) (U (tfo_apply o2 o37) (tfo_apply o2 o36) (tfo_apply o2 o35) (tfo_apply o2 o34) (tfo_apply o2 o33)));

v120 o4 o3 o2 o1 = case o1 of
	<1> -> Cons{1,0};
	<2> o6 o5 -> if (o2 o6 o4) (search (o6 : o4) o3 o2 ++ v120 o4 o3 o2 o5)
			(v120 o4 o3 o2 o5);

search o3 o2 o1 = case o2 of
	<1> -> Cons{2,2} o3 Cons{1,0};
	<2> o5 o4 -> v120 o3 o4 o1 (o5 o3);

v123 o1 = case o1 of
	<1> o4 o3 o2 -> o1;

dgf_base o3 o2 o1 =
 let o7 = v123 o2;
 in case o7 of 
 	<1> o6 o5 o4 -> let o8 = if (is_A o4) (tfo_align (atom_pos nuc_C1' o2) (atom_pos rA_N9 o2) (atom_pos nuc_C4 o2))
			(if (is_C o4) (tfo_align (atom_pos nuc_C1' o2) (atom_pos nuc_N1 o2) (atom_pos nuc_C2 o2))
 			(if (is_G o4) (tfo_align (atom_pos nuc_C1' o2) (atom_pos rG_N9 o2) (atom_pos nuc_C4 o2))
			(tfo_align (atom_pos nuc_C1' o2) (atom_pos nuc_N1 o2) (atom_pos nuc_C2 o2))))
		in  tfo_combine (nuc_dgf_base_tfo o1) (tfo_combine o3 (tfo_inv_ortho o8));

reference o3 o2 o1 = Cons{2,2} (mk_var o2 tfo_id o3) Cons{1,0};

wc_tfo = Cons{1,12} (negate Top) Top (negate Top) Top Top (negate Top) (negate Top) (negate Top) (negate Top) (negate Top) Top Top;

wc o4 o3 o2 o1 = Cons{2,2} (mk_var o3 (dgf_base wc_tfo (get_var o2 o1) o4) o4) Cons{1,0};

wc_dumas_tfo = Cons{1,12} (negate Top) (negate Top) Top (negate Top) Top (negate Top) Top (negate Top) (negate Top) Top Top Top;

wc_dumas o4 o3 o2 o1 = Cons{2,2} (mk_var o3 (dgf_base wc_dumas_tfo (get_var o2 o1) o4) o4) Cons{1,0};

helix5'_tfo = Cons{1,12} Top (negate Top) Top Top Top (negate Top) (negate Top) Top Top (negate Top) Top Top;

helix5' o4 o3 o2 o1 = Cons{2,2} (mk_var o3 (dgf_base helix5'_tfo (get_var o2 o1) o4) o4) Cons{1,0};

helix3'_tfo = Cons{1,12} Top Top (negate Top) (negate Top) Top Top Top (negate Top) Top Top Top (negate Top);

helix3' o4 o3 o2 o1 = Cons{2,2} (mk_var o3 (dgf_base helix3'_tfo (get_var o2 o1) o4) o4) Cons{1,0};

g37_a38_tfo = Cons{1,12} Top Top (negate Top) (negate Top) Top (negate Top) Top Top Top (negate Top) Top Top;

g37_a38 o4 o3 o2 o1 = mk_var o3 (dgf_base g37_a38_tfo (get_var o2 o1) o4) o4;

stacked5' o4 o3 o2 o1 = Cons{2,2} (g37_a38 o4 o3 o2 o1) (helix5' o4 o3 o2 o1);

a38_g37_tfo = Cons{1,12} Top (negate Top) Top Top Top Top (negate Top) (negate Top) Top Top Top (negate Top);

a38_g37 o4 o3 o2 o1 = mk_var o3 (dgf_base a38_g37_tfo (get_var o2 o1) o4) o4;

stacked3' o4 o3 o2 o1 = Cons{2,2} (a38_g37 o4 o3 o2 o1) (helix3' o4 o3 o2 o1);

v124 o4 o3 o2 o1 = case o1 of
	<1> -> o2;
	<2> o6 o5 -> v124 o4 o3 (Cons{2,2} (mk_var o4 (tfo_combine (nuc_p_o3'_60_tfo o6) o3) o6) (Cons{2,2} (mk_var o4 (tfo_combine (nuc_p_o3'_180_tfo o6) o3) o6) (Cons{2,2} (mk_var o4 (tfo_combine (nuc_p_o3'_275_tfo o6) o3) o6) o2))) o5;

p_o3' o4 o3 o2 o1 = let o5 = get_var o2 o1;
	o6 = tfo_inv_ortho (tfo_align (atom_pos nuc_O3' o5) (atom_pos nuc_C3' o5) (atom_pos nuc_C4' o5));
		in  v124 o3 o6 Cons{1,0} o4;

anticodon_domains = Cons{2,2} (reference rC 27) (Cons{2,2} (helix5' rC 28 27) (Cons{2,2} (helix5' rA 29 28) (Cons{2,2} (helix5' rG 30 29) (Cons{2,2} (helix5' rA 31 30) (Cons{2,2} (wc rU 39 31) (Cons{2,2} (helix5' rC 40 39) (Cons{2,2} (helix5' rU 41 40) (Cons{2,2} (helix5' rG 42 41) (Cons{2,2} (helix5' rG 43 42) (Cons{2,2} (stacked3' rA 38 39) (Cons{2,2} (stacked3' rG 37 38) (Cons{2,2} (stacked3' rA 36 37) (Cons{2,2} (stacked3' rA 35 36) (Cons{2,2} (stacked3' rG 34 35) (Cons{2,2} (p_o3' rCs 32 31) (Cons{2,2} (p_o3' rUs 33 32) Cons{1,0}))))))))))))))));

v127 o1 = case o1 of
	<1> o4 o3 o2 -> o1;

v128 o3 o2 o1 = let o4 = atom_pos nuc_P (get_var o1 o2);
		o5 = atom_pos nuc_O3' o3;
		in  pt_dist o4 o5;

anticodon_constraint o2 o1 = 
 let o6 = v127 o2;
 in case o6 of
 	<1> o5 o4 o3 -> if (o5 == 33) (fle (v128 o2 o1 34) Top)
				Cons{2,0};

anticodon = search Cons{1,0} anticodon_domains anticodon_constraint;

pseudoknot_domains = Cons{2,2} (reference rA 23) (Cons{2,2} (wc_dumas rU 8 23) (Cons{2,2} (helix3' rG 22 23) (Cons{2,2} (wc_dumas rC 9 22) (Cons{2,2} (helix3' rG 21 22) (Cons{2,2} (wc_dumas rC 10 21) (Cons{2,2} (helix3' rC 20 21) (Cons{2,2} (wc_dumas rG 11 20) (Cons{2,2} (helix3' rU' 19 20) (Cons{2,2} (wc_dumas rA 12 19) (Cons{2,2} (helix3' rC 3 19) (Cons{2,2} (wc_dumas rG 13 3) (Cons{2,2} (helix3' rC 2 3) (Cons{2,2} (wc_dumas rG 14 2) (Cons{2,2} (helix3' rC 1 2) (Cons{2,2} (wc_dumas rG' 15 1) (Cons{2,2} (p_o3' rUs 16 15) (Cons{2,2} (p_o3' rCs 17 16) (Cons{2,2} (p_o3' rAs 18 17) (Cons{2,2} (helix3' rU 7 8) (Cons{2,2} (p_o3' rCs 4 3) (Cons{2,2} (stacked5' rU 5 4) (Cons{2,2} (stacked5' rC 6 5) Cons{1,0}))))))))))))))))))))));

v131 o1 = case o1 of
	<1> o4 o3 o2 -> o1;

v132 o3 o2 o1 = let o4 = atom_pos nuc_P (get_var o1 o2);
		    o5 = atom_pos nuc_O3' o3;
		in  pt_dist o4 o5;

pseudoknot_constraint o2 o1 = 
 let o6 = v131 o2;
 in case o6 of
 	<1> o5 o4 o3 -> if (o5 == 18) (fle (v132 o2 o1 19) Top)
				(if (o5 == 6) (fle (v132 o2 o1 7) Top)
					Cons{2,0});

pseudoknot = search Cons{1,0} pseudoknot_domains pseudoknot_constraint;

list_of_specific_atoms o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> (case o2 of
		<1> o39 o38 o37 o36 o35 o34 o33 o32 -> Cons{2,2} o39 (Cons{2,2} o38 (Cons{2,2} o37 (Cons{2,2} o36 (Cons{2,2} o35 (Cons{2,2} o34 (Cons{2,2} o33 (Cons{2,2} o32 Cons{1,0})))))));
		<2> o37 o36 o35 o34 o33 o32 -> Cons{2,2} o37 (Cons{2,2} o36 (Cons{2,2} o35 (Cons{2,2} o34 (Cons{2,2} o33 (Cons{2,2} o32 Cons{1,0})))));
		<3> o40 o39 o38 o37 o36 o35 o34 o33 o32 -> Cons{2,2} o40 (Cons{2,2} o39 (Cons{2,2} o38 (Cons{2,2} o37 (Cons{2,2} o36 (Cons{2,2} o35 (Cons{2,2} o34 (Cons{2,2} o33 (Cons{2,2} o32 Cons{1,0}))))))));
		<4> o36 o35 o34 o33 o32 -> Cons{2,2} o36 (Cons{2,2} o35 (Cons{2,2} o34 (Cons{2,2} o33 (Cons{2,2} o32 Cons{1,0})))));

list_of_common_atoms o1 = case o1 of
	<1> o31 o30 o29 o28 o27 o26 o25 o24 o23 o22 o21 o20 o19 o18 o17 o16 o15 o14 o13 o12 o11 o10 o9 o8 o7 o6 o5 o4 o3 o2 -> Cons{2,2} o27 (Cons{2,2} o26 (Cons{2,2} o25 (Cons{2,2} o24 (Cons{2,2} o23 (Cons{2,2} o22 (Cons{2,2} o21 (Cons{2,2} o20 (Cons{2,2} o19 (Cons{2,2} o18 (Cons{2,2} o17 (Cons{2,2} o16 (Cons{2,2} o15 (Cons{2,2} o14 (Cons{2,2} o13 (Cons{2,2} o12 (Cons{2,2} o11 (Cons{2,2} o10 (Cons{2,2} o9 (Cons{2,2} o8 (Cons{2,2} o7 (Cons{2,2} o6 (Cons{2,2} o5 (Cons{2,2} o4 (Cons{2,2} o3 Cons{1,0}))))))))))))))))))))))));

list_of_atoms o1 = append (list_of_common_atoms o1) (list_of_specific_atoms o1);

v133 o2 o1 = case o1 of
	<1> -> o2;
	<2> o4 o3 -> if (fgt o4 o2) (v133 o4 o3)
				(v133 o2 o3);

maximum' o1 = case o1 of
	<2> o3 o2 -> v133 o3 o2;

v138 o1 = case o1 of
	<1> o4 o3 o2 -> o1;

v140 o1 = case o1 of
	<1> o4 o3 o2 -> o1;

v139 o2 o1 = let o6 = v140 (absolute_pos o2 o1);
 	     in case o6 of 
		<1> o5 o4 o3 -> fsqrt (o5 * o5 + o4 * o4 + o3 * o3);

var_most_distant_atom o1 = let o5 = v138 o1;
			   in case o5 of
				<1> o4 o3 o2 -> maximum' (map (v139 o1) (list_of_atoms o2));

sol_most_distant_atom o1 = maximum' (map var_most_distant_atom o1);

most_distant_atom o1 = maximum' (map sol_most_distant_atom o1);

check = length pseudoknot;

run' = most_distant_atom pseudoknot;

main = appendChan stdout (show run') exit done;

/* end of nucleic2.gsc */
