>

> module Main where
> main :: Dialogue
> main ~(StrList progArgs : ~(r3 :_)) =
>  [
>   GetArgs,
>    ReadFile name,
>    AppendChan stdout 
>       (case r3 of
>           Str contents -> 
>               unhex contents
>           Failure _ -> "Can't open " ++ name)]
>   where 
>      (name :_) = progArgs
>
> convert :: String -> Int
> convert ss = foldl multadd 0 [(ord s) - (ord '0') | s <- ss]
>   where multadd z x = z*10+x
>
> hexdigit = "0123456789abcdef"
> hexord :: Char -> Int
> hexord x = rank x hexdigit
>
> rank :: Eq a => a -> [a] -> Int
> rank x (y:ys) 
>   | x == y = 0
>   | otherwise = 1 + rank x ys
> {-# SPECIALIZE rank :: Char -> String -> Int #-}
>
> unhex :: String -> String
> unhex [] = []
> unhex ('0':'x':xs) = show (foldl multadd 0 [hexord c| c <- a]) ++ unhex e
>   where (a, e) = span (\ r -> r `elem` hexdigit) xs
>         multadd z x = z*16+x
> unhex (x:xs) = x:unhex xs



% file ends here







