>

Dieser Abschnitt definiert die vom Compiler verwendeten Typen.

> module CompilerTypes where
> import AbsSyntax
> import StateType
> import Utils

Hier sind nun einige Typen, die der Compiler ben"otigt. Zun"achst
einmal der Type @GmCompiledSC@, den "ubersetzte Superkombinatoren
erhalten.

> type GmCompiledSC = (Name, Int, GmCode)

Ein @GmCompiler@ ist dann eine Funktion, die einen Syntaxbaum mit
einer Umgebung, die Namen relative Stapeladressen zuordnet, auf eine
Anweisungsfolge abbildet.

> type GmCompiler = CoreExpr -> GmEnvironment -> GmCode

 type GmEnvironment = FiniteMap Name Int

> type GmEnvironment = AssocList Name Int


%file ends here
